diff --git a/src/backend/executor/nodeWindowAgg.c b/src/backend/executor/nodeWindowAgg.c
index 0b558e5..2b64175 100644
*** a/src/backend/executor/nodeWindowAgg.c
--- b/src/backend/executor/nodeWindowAgg.c
*************** eval_windowaggregates(WindowAggState *wi
*** 589,616 ****
  		 * advance that the next row can't possibly share the same frame. Is
  		 * it worth detecting that and skipping this code?
  		 */
! 		if (!peraggstate->resulttypeByVal)
  		{
! 			/*
! 			 * clear old resultValue in order not to leak memory.  (Note: the
! 			 * new result can't possibly be the same datum as old resultValue,
! 			 * because we never passed it to the trans function.)
! 			 */
! 			if (!peraggstate->resultValueIsNull)
! 				pfree(DatumGetPointer(peraggstate->resultValue));
! 
! 			/*
! 			 * If pass-by-ref, copy it into our aggregate context.
! 			 */
! 			if (!*isnull)
! 			{
! 				oldContext = MemoryContextSwitchTo(winstate->aggcontext);
! 				peraggstate->resultValue =
! 					datumCopy(*result,
! 							  peraggstate->resulttypeByVal,
! 							  peraggstate->resulttypeLen);
! 				MemoryContextSwitchTo(oldContext);
! 			}
  		}
  		else
  		{
--- 964,977 ----
  		 * advance that the next row can't possibly share the same frame. Is
  		 * it worth detecting that and skipping this code?
  		 */
! 		if (!peraggstate->resulttypeByVal && !*isnull)
  		{
! 			oldContext = MemoryContextSwitchTo(peraggstate->aggcontext);
! 			peraggstate->resultValue =
! 				datumCopy(*result,
! 						  peraggstate->resulttypeByVal,
! 						  peraggstate->resulttypeLen);
! 			MemoryContextSwitchTo(oldContext);
  		}
  		else
  		{
*************** eval_windowfunction(WindowAggState *wins
*** 651,656 ****
--- 1012,1018 ----
  	/* Just in case, make all the regular argument slots be null */
  	memset(fcinfo.argnull, true, perfuncstate->numArguments);
  
+ 	winstate->calledaggno = -1;
  	*result = FunctionCallInvoke(&fcinfo);
  	*isnull = fcinfo.isnull;
  
*************** spool_tuples(WindowAggState *winstate, i
*** 794,800 ****
  	 * becomes quite expensive due to frequent buffer flushes.	It's cheaper
  	 * to force the entire partition to get spooled in one go.
  	 *
! 	 * XXX this is a horrid kluge --- it'd be better to fix the performance
  	 * problem inside tuplestore.  FIXME
  	 */
  	if (!tuplestore_in_memory(winstate->buffer))
--- 1156,1162 ----
  	 * becomes quite expensive due to frequent buffer flushes.	It's cheaper
  	 * to force the entire partition to get spooled in one go.
  	 *
! 	 * XXX this is a horrid kludge --- it'd be better to fix the performance
  	 * problem inside tuplestore.  FIXME
  	 */
  	if (!tuplestore_in_memory(winstate->buffer))
*************** release_partition(WindowAggState *winsta
*** 869,875 ****
  	 * aggregates might have allocated data we don't have direct pointers to.
  	 */
  	MemoryContextResetAndDeleteChildren(winstate->partcontext);
! 	MemoryContextResetAndDeleteChildren(winstate->aggcontext);
  
  	if (winstate->buffer)
  		tuplestore_end(winstate->buffer);
--- 1231,1240 ----
  	 * aggregates might have allocated data we don't have direct pointers to.
  	 */
  	MemoryContextResetAndDeleteChildren(winstate->partcontext);
! 	MemoryContextResetAndDeleteChildren(winstate->aggcontext_shared);
! 	for (i = 0; i < winstate->numaggs; ++i)
! 		if (!winstate->peragg[i].aggcontext_is_shared)
! 			MemoryContextResetAndDeleteChildren(winstate->peragg[i].aggcontext);
  
  	if (winstate->buffer)
  		tuplestore_end(winstate->buffer);
*************** ExecInitWindowAgg(WindowAgg *node, EStat
*** 1419,1425 ****
  	int			numfuncs,
  				wfuncno,
  				numaggs,
! 				aggno;
  	ListCell   *l;
  
  	/* check for unsupported flags */
--- 1784,1791 ----
  	int			numfuncs,
  				wfuncno,
  				numaggs,
! 				aggno,
! 				numaggs_invtrans;
  	ListCell   *l;
  
  	/* check for unsupported flags */
*************** ExecInitWindowAgg(WindowAgg *node, EStat
*** 1450,1457 ****
  							  ALLOCSET_DEFAULT_INITSIZE,
  							  ALLOCSET_DEFAULT_MAXSIZE);
  
! 	/* Create mid-lived context for aggregate trans values etc */
! 	winstate->aggcontext =
  		AllocSetContextCreate(CurrentMemoryContext,
  							  "WindowAgg_Aggregates",
  							  ALLOCSET_DEFAULT_MINSIZE,
--- 1816,1825 ----
  							  ALLOCSET_DEFAULT_INITSIZE,
  							  ALLOCSET_DEFAULT_MAXSIZE);
  
! 	/* Create mid-lived contexts for aggregate trans values etc
! 	 * Note that invertible aggregates use their own private context
! 	 */
! 	winstate->aggcontext_shared =
  		AllocSetContextCreate(CurrentMemoryContext,
  							  "WindowAgg_Aggregates",
  							  ALLOCSET_DEFAULT_MINSIZE,
*************** ExecInitWindowAgg(WindowAgg *node, EStat
*** 1535,1540 ****
--- 1903,1909 ----
  
  	wfuncno = -1;
  	aggno = -1;
+ 	numaggs_invtrans = 0;
  	foreach(l, winstate->funcs)
  	{
  		WindowFuncExprState *wfuncstate = (WindowFuncExprState *) lfirst(l);
*************** ExecInitWindowAgg(WindowAgg *node, EStat
*** 1603,1608 ****
--- 1972,1979 ----
  			peraggstate = &winstate->peragg[aggno];
  			initialize_peragg(winstate, wfunc, peraggstate);
  			peraggstate->wfuncno = wfuncno;
+ 			if (peraggstate->use_invtransfn)
+ 				numaggs_invtrans++;
  		}
  		else
  		{
*************** ExecInitWindowAgg(WindowAgg *node, EStat
*** 1618,1623 ****
--- 1989,1995 ----
  	/* Update numfuncs, numaggs to match number of unique functions found */
  	winstate->numfuncs = wfuncno + 1;
  	winstate->numaggs = aggno + 1;
+ 	winstate->numaggs_invtrans = numaggs_invtrans;
  
  	/* Set up WindowObject for aggregates, if needed */
  	if (winstate->numaggs > 0)
*************** ExecInitWindowAgg(WindowAgg *node, EStat
*** 1646,1651 ****
--- 2018,2029 ----
  	winstate->partition_spooled = false;
  	winstate->more_partitions = false;
  
+ 	/* initialize temporary data */
+ 	winstate->calledaggno = -1;
+ 
+ 	/* initialize statistics */
+ 	winstate->aggfwdtrans = 0;
+ 
  	return winstate;
  }
  
*************** void
*** 1657,1668 ****
  ExecEndWindowAgg(WindowAggState *node)
  {
  	PlanState  *outerPlan;
  
  	release_partition(node);
  
- 	pfree(node->perfunc);
- 	pfree(node->peragg);
- 
  	ExecClearTuple(node->ss.ss_ScanTupleSlot);
  	ExecClearTuple(node->first_part_slot);
  	ExecClearTuple(node->agg_row_slot);
--- 2035,2044 ----
  ExecEndWindowAgg(WindowAggState *node)
  {
  	PlanState  *outerPlan;
+ 	int			i;
  
  	release_partition(node);
  
  	ExecClearTuple(node->ss.ss_ScanTupleSlot);
  	ExecClearTuple(node->first_part_slot);
  	ExecClearTuple(node->agg_row_slot);
*************** ExecEndWindowAgg(WindowAggState *node)
*** 1677,1683 ****
  	ExecFreeExprContext(&node->ss.ps);
  
  	MemoryContextDelete(node->partcontext);
! 	MemoryContextDelete(node->aggcontext);
  
  	outerPlan = outerPlanState(node);
  	ExecEndNode(outerPlan);
--- 2053,2065 ----
  	ExecFreeExprContext(&node->ss.ps);
  
  	MemoryContextDelete(node->partcontext);
! 	MemoryContextDelete(node->aggcontext_shared);
! 	for(i = 0; i < node->numaggs; i++)
! 		if (!node->peragg[i].aggcontext_is_shared)
! 			MemoryContextDelete(node->peragg[i].aggcontext);
! 
! 	pfree(node->perfunc);
! 	pfree(node->peragg);
  
  	outerPlan = outerPlanState(node);
  	ExecEndNode(outerPlan);
*************** initialize_peragg(WindowAggState *winsta
*** 1735,1742 ****
--- 2117,2126 ----
  	Oid			aggtranstype;
  	AclResult	aclresult;
  	Oid			transfn_oid,
+ 				invtransfn_oid,
  				finalfn_oid;
  	Expr	   *transfnexpr,
+ 			   *invtransfnexpr,
  			   *finalfnexpr;
  	Datum		textInitVal;
  	int			i;
*************** initialize_peragg(WindowAggState *winsta
*** 1762,1767 ****
--- 2146,2152 ----
  	 */
  
  	peraggstate->transfn_oid = transfn_oid = aggform->aggtransfn;
+ 	peraggstate->invtransfn_oid = invtransfn_oid = aggform->agginvtransfn;
  	peraggstate->finalfn_oid = finalfn_oid = aggform->aggfinalfn;
  
  	/* Check that aggregate owner has permission to call component fns */
*************** initialize_peragg(WindowAggState *winsta
*** 1783,1788 ****
--- 2168,2184 ----
  			aclcheck_error(aclresult, ACL_KIND_PROC,
  						   get_func_name(transfn_oid));
  		InvokeFunctionExecuteHook(transfn_oid);
+ 
+ 		if (OidIsValid(invtransfn_oid))
+ 		{
+ 			aclresult = pg_proc_aclcheck(invtransfn_oid, aggOwner,
+ 										 ACL_EXECUTE);
+ 			if (aclresult != ACLCHECK_OK)
+ 				aclcheck_error(aclresult, ACL_KIND_PROC,
+ 				get_func_name(invtransfn_oid));
+ 			InvokeFunctionExecuteHook(invtransfn_oid);
+ 		}
+ 
  		if (OidIsValid(finalfn_oid))
  		{
  			aclresult = pg_proc_aclcheck(finalfn_oid, aggOwner,
*************** initialize_peragg(WindowAggState *winsta
*** 1810,1822 ****
--- 2206,2226 ----
  							wfunc->wintype,
  							wfunc->inputcollid,
  							transfn_oid,
+ 							invtransfn_oid,
  							finalfn_oid,
  							&transfnexpr,
+ 							&invtransfnexpr,
  							&finalfnexpr);
  
  	fmgr_info(transfn_oid, &peraggstate->transfn);
  	fmgr_info_set_expr((Node *) transfnexpr, &peraggstate->transfn);
  
+ 	if (OidIsValid(invtransfn_oid))
+ 	{
+ 		fmgr_info(invtransfn_oid, &peraggstate->invtransfn);
+ 		fmgr_info_set_expr((Node *) invtransfnexpr, &peraggstate->invtransfn);
+ 	}
+ 
  	if (OidIsValid(finalfn_oid))
  	{
  		fmgr_info(finalfn_oid, &peraggstate->finalfn);
*************** initialize_peragg(WindowAggState *winsta
*** 1860,1867 ****
--- 2264,2337 ----
  							wfunc->winfnoid)));
  	}
  
+ 	/*
+ 	 * Allowing only the forward transition function to be strict would
+ 	 * require handling more special cases in advance_windowaggregate() and
+ 	 * retreat_windowaggregate(), for no discernible benefit. So we ensure
+ 	 * that if the forward transition function is strict that the inverse
+ 	 * transition function is also strict. This should have been checked at
+ 	 * the aggregate function's definition time, but it's better to be safe...
+ 	 */
+ 	if (OidIsValid(invtransfn_oid) &&
+ 		peraggstate->transfn.fn_strict != peraggstate->invtransfn.fn_strict)
+ 	{
+ 		ereport(ERROR,
+ 				(errcode(ERRCODE_INVALID_FUNCTION_DEFINITION),
+ 				errmsg("strictness of forward and inverse transition functions must match")));
+ 	}
+ 
  	ReleaseSysCache(aggTuple);
  
+ 	/*
+ 	 * We can use the inverse transition function only if the aggregate's
+ 	 * arguments don't contain calls to volatile functions. Otherwise,
+ 	 * the difference between restarting and not restarting the aggregation
+ 	 * would be user-visible. Note that this check also covers the case where
+ 	 * the FILTER's WHERE clause contains a volatile function. If the frame
+ 	 * head cannot move, we won't ever need the inverse transition function,
+ 	 * so we also mark as "don't use" in that case.
+ 	 */
+ 	if (OidIsValid(invtransfn_oid) &&
+ 		!contain_volatile_functions((Node *) wfunc) &&
+ 		!(winstate->frameOptions & FRAMEOPTION_START_UNBOUNDED_PRECEDING))
+ 	{
+ 		peraggstate->use_invtransfn = true;
+ 	}
+ 	else
+ 	{
+ 		peraggstate->use_invtransfn = false;
+ 	}
+ 
+ 	/*
+ 	 * Invertible aggregates use their own aggcontext.
+ 	 *
+ 	 * This is necessary because they might all restart at different times,
+ 	 * so we might never be able to reset the shared context otherwise. We
+ 	 * can't make it the aggregate's responsibility to clean up after
+ 	 * themselves, because strict aggregates must be restarted whenever we
+ 	 * remove their last non-NULL input, which the aggregate won't be aware
+ 	 * is happening. Also, just pfree()ing the transValue upon restarting
+ 	 * wouldn't help, since we'd miss any indirectly referenced data. We
+ 	 * could, in theory, declare that aggregates with a state type other then
+ 	 * "internal" musn't allocate anything in the aggcontext themselves, that
+ 	 * non-strict aggregates with state type internal must clean up after
+ 	 * themselves when their inverse transfer function returns NULL, and then
+ 	 * only use private aggcontexts for strict aggregates with state type
+ 	 * internal. But that'd be a rather grotty set of requirements.
+ 	 */
+ 	peraggstate->aggcontext_is_shared = !peraggstate->use_invtransfn;
+ 	if (!peraggstate->aggcontext_is_shared)
+ 	{
+ 		peraggstate->aggcontext =
+ 			AllocSetContextCreate(CurrentMemoryContext,
+ 								  "WindowAgg_AggregatePrivate",
+ 								  ALLOCSET_DEFAULT_MINSIZE,
+ 								  ALLOCSET_DEFAULT_INITSIZE,
+ 								  ALLOCSET_DEFAULT_MAXSIZE);
+ 	}
+ 	else
+ 		peraggstate->aggcontext = winstate->aggcontext_shared;
+ 
  	return peraggstate;
  }
  
diff --git a/src/backend/parser/parse_agg.c b/src/backend/parser/parse_agg.c
index 9613e2a..ef84e4c 100644
*** a/src/backend/parser/parse_agg.c
--- b/src/backend/parser/parse_agg.c
*************** resolve_aggregate_transtype(Oid aggfunci
*** 1187,1197 ****
   * For an ordered-set aggregate, remember that agg_input_types describes
   * the direct arguments followed by the aggregated arguments.
   *
!  * transfn_oid and finalfn_oid identify the funcs to be called; the latter
!  * may be InvalidOid.
   *
!  * Pointers to the constructed trees are returned into *transfnexpr and
!  * *finalfnexpr.  The latter is set to NULL if there's no finalfn.
   */
  void
  build_aggregate_fnexprs(Oid *agg_input_types,
--- 1187,1199 ----
   * For an ordered-set aggregate, remember that agg_input_types describes
   * the direct arguments followed by the aggregated arguments.
   *
!  * transfn_oid, invtransfn_oid and finalfn_oid identify the funcs to be
!  * called; the latter two may be InvalidOid.
   *
!  * Pointers to the constructed trees are returned into *transfnexpr,
!  * *invtransfnexpr and *finalfnexpr. If there is invtransfn or finalfn, the
!  * respective pointers are set to NULL. Since use of the invtransfn is
!  * optional, NULL may be passed for invtransfnexpr.
   */
  void
  build_aggregate_fnexprs(Oid *agg_input_types,
*************** build_aggregate_fnexprs(Oid *agg_input_t
*** 1203,1210 ****
--- 1205,1214 ----
  						Oid agg_result_type,
  						Oid agg_input_collation,
  						Oid transfn_oid,
+ 						Oid invtransfn_oid,
  						Oid finalfn_oid,
  						Expr **transfnexpr,
+ 						Expr **invtransfnexpr,
  						Expr **finalfnexpr)
  {
  	Param	   *argp;
*************** build_aggregate_fnexprs(Oid *agg_input_t
*** 1249,1254 ****
--- 1253,1270 ----
  	fexpr->funcvariadic = agg_variadic;
  	*transfnexpr = (Expr *) fexpr;
  
+ 	if (OidIsValid(invtransfn_oid) && invtransfnexpr != NULL)
+ 	{
+ 		*invtransfnexpr = (Expr *) makeFuncExpr(invtransfn_oid,
+ 												agg_result_type,
+ 												args,
+ 												InvalidOid,
+ 												agg_input_collation,
+ 												COERCE_EXPLICIT_CALL);
+ 	}
+ 	else if (invtransfnexpr != NULL)
+ 		*invtransfnexpr	= NULL;
+ 
  	/* see if we have a final function */
  	if (!OidIsValid(finalfn_oid))
  	{
diff --git a/src/bin/pg_dump/pg_dump.c b/src/bin/pg_dump/pg_dump.c
index 2ce8e6d..21a7347 100644
*** a/src/bin/pg_dump/pg_dump.c
--- b/src/bin/pg_dump/pg_dump.c
*************** dumpAgg(Archive *fout, AggInfo *agginfo)
*** 11512,11517 ****
--- 11512,11518 ----
  	char	   *aggsig_tag;
  	PGresult   *res;
  	int			i_aggtransfn;
+ 	int			i_agginvtransfn;
  	int			i_aggfinalfn;
  	int			i_aggsortop;
  	int			i_hypothetical;
*************** dumpAgg(Archive *fout, AggInfo *agginfo)
*** 11520,11525 ****
--- 11521,11527 ----
  	int			i_agginitval;
  	int			i_convertok;
  	const char *aggtransfn;
+ 	const char *agginvtransfn;
  	const char *aggfinalfn;
  	const char *aggsortop;
  	bool		hypothetical;
*************** dumpAgg(Archive *fout, AggInfo *agginfo)
*** 11544,11550 ****
  	/* Get aggregate-specific details */
  	if (fout->remoteVersion >= 90400)
  	{
! 		appendPQExpBuffer(query, "SELECT aggtransfn, "
  						  "aggfinalfn, aggtranstype::pg_catalog.regtype, "
  						  "aggsortop::pg_catalog.regoperator, "
  						  "(aggkind = 'h') as hypothetical, "
--- 11546,11552 ----
  	/* Get aggregate-specific details */
  	if (fout->remoteVersion >= 90400)
  	{
! 		appendPQExpBuffer(query, "SELECT aggtransfn, agginvtransfn, "
  						  "aggfinalfn, aggtranstype::pg_catalog.regtype, "
  						  "aggsortop::pg_catalog.regoperator, "
  						  "(aggkind = 'h') as hypothetical, "
*************** dumpAgg(Archive *fout, AggInfo *agginfo)
*** 11560,11565 ****
--- 11562,11568 ----
  	else if (fout->remoteVersion >= 80400)
  	{
  		appendPQExpBuffer(query, "SELECT aggtransfn, "
+ 						  "'-'::pg_catalog.regproc AS agginvtransfn, "
  						  "aggfinalfn, aggtranstype::pg_catalog.regtype, "
  						  "aggsortop::pg_catalog.regoperator, "
  						  "false as hypothetical, "
*************** dumpAgg(Archive *fout, AggInfo *agginfo)
*** 11575,11580 ****
--- 11578,11584 ----
  	else if (fout->remoteVersion >= 80100)
  	{
  		appendPQExpBuffer(query, "SELECT aggtransfn, "
+ 						  "'-'::pg_catalog.regproc AS agginvtransfn, "
  						  "aggfinalfn, aggtranstype::pg_catalog.regtype, "
  						  "aggsortop::pg_catalog.regoperator, "
  						  "false as hypothetical, "
*************** dumpAgg(Archive *fout, AggInfo *agginfo)
*** 11588,11593 ****
--- 11592,11598 ----
  	else if (fout->remoteVersion >= 70300)
  	{
  		appendPQExpBuffer(query, "SELECT aggtransfn, "
+ 						  "'-'::pg_catalog.regproc AS agginvtransfn, "
  						  "aggfinalfn, aggtranstype::pg_catalog.regtype, "
  						  "0 AS aggsortop, "
  						  "'f'::boolean as hypothetical, "
*************** dumpAgg(Archive *fout, AggInfo *agginfo)
*** 11600,11606 ****
  	}
  	else if (fout->remoteVersion >= 70100)
  	{
! 		appendPQExpBuffer(query, "SELECT aggtransfn, aggfinalfn, "
  						  "format_type(aggtranstype, NULL) AS aggtranstype, "
  						  "0 AS aggsortop, "
  						  "'f'::boolean as hypothetical, "
--- 11605,11613 ----
  	}
  	else if (fout->remoteVersion >= 70100)
  	{
! 		appendPQExpBuffer(query, "SELECT aggtransfn, "
! 						  "'-'::pg_catalog.regproc AS agginvtransfn, "
! 						  "aggfinalfn, "
  						  "format_type(aggtranstype, NULL) AS aggtranstype, "
  						  "0 AS aggsortop, "
  						  "'f'::boolean as hypothetical, "
*************** dumpAgg(Archive *fout, AggInfo *agginfo)
*** 11613,11618 ****
--- 11620,11626 ----
  	else
  	{
  		appendPQExpBuffer(query, "SELECT aggtransfn1 AS aggtransfn, "
+ 						  "'-'::pg_catalog.regproc AS agginvtransfn, "
  						  "aggfinalfn, "
  						  "(SELECT typname FROM pg_type WHERE oid = aggtranstype1) AS aggtranstype, "
  						  "0 AS aggsortop, "
*************** dumpAgg(Archive *fout, AggInfo *agginfo)
*** 11627,11632 ****
--- 11635,11641 ----
  	res = ExecuteSqlQueryForSingleRow(fout, query->data);
  
  	i_aggtransfn = PQfnumber(res, "aggtransfn");
+ 	i_agginvtransfn = PQfnumber(res, "agginvtransfn");
  	i_aggfinalfn = PQfnumber(res, "aggfinalfn");
  	i_aggsortop = PQfnumber(res, "aggsortop");
  	i_hypothetical = PQfnumber(res, "hypothetical");
*************** dumpAgg(Archive *fout, AggInfo *agginfo)
*** 11636,11641 ****
--- 11645,11651 ----
  	i_convertok = PQfnumber(res, "convertok");
  
  	aggtransfn = PQgetvalue(res, 0, i_aggtransfn);
+ 	agginvtransfn = PQgetvalue(res, 0, i_agginvtransfn);
  	aggfinalfn = PQgetvalue(res, 0, i_aggfinalfn);
  	aggsortop = PQgetvalue(res, 0, i_aggsortop);
  	hypothetical = (PQgetvalue(res, 0, i_hypothetical)[0] == 't');
*************** dumpAgg(Archive *fout, AggInfo *agginfo)
*** 11694,11699 ****
--- 11704,11715 ----
  						  fmtId(aggtranstype));
  	}
  
+ 	if (strcmp(agginvtransfn, "-") != 0)
+ 	{
+ 		appendPQExpBuffer(details, ",\n    INVSFUNC = %s",
+ 						  agginvtransfn);
+ 	}
+ 
  	if (strcmp(aggtransspace, "0") != 0)
  	{
  		appendPQExpBuffer(details, ",\n    SSPACE = %s",
